#include <alloc.h>
#include <dos.h>
#include <stdio.h>

extern TestMovs (char _far *src, char _far *dest, unsigned len);
extern TestSep (char _far *src, char _far *dest, unsigned len);
extern TestSepOff (char _far *src, char _far *dest, unsigned len);

long get_time (void)
{
struct dostime_t t;

	_dos_gettime (&t);
	return (((long) (t.hour * 60 + t.minute) * 60L + (long) t.second) * 100L + (long) t.hsecond);
}

int main ()
{
char _far *src, _far *dest;
long lStart, lDiff;

	printf ("Do not run when it will change days while running (midnight)\n");

	src = farmalloc (0x8008);
	dest = farmalloc (0x8008);
	if ((src == NULL) || (dest == NULL))
		{
		printf ("couldn't alloc memory\n");
		return (1);
		}

	if (FP_OFF (src) & 3)
		src += 4 - (FP_OFF (src) & 3);
	if (FP_OFF (dest) & 3)
		dest += 4 - (FP_OFF (dest) & 3);

	lStart = get_time ();
	TestMovs (src, dest, 0x8000);
	lDiff = get_time () - lStart;
	printf ("Movs DWORD align = %ld hundredths\n", lDiff);

	lStart = get_time ();
	TestMovs (src + 1, dest, 0x8000);
	lDiff = get_time () - lStart;
	printf ("Movs src +1 = %ld hundredths\n", lDiff);

	lStart = get_time ();
	TestMovs (src, dest + 1, 0x8000);
	lDiff = get_time () - lStart;
	printf ("Movs dest + 1 = %ld hundredths\n", lDiff);

	lStart = get_time ();
	TestMovs (src+1, dest+3, 0x8000);
	lDiff = get_time () - lStart;
	printf ("Movs src + 1, dest + 3 = %ld hundredths\n", lDiff);

	lStart = get_time ();
	TestSep (src, dest, 0x8000);
	lDiff = get_time () - lStart;
	printf ("Seperate instructions DWORD align = %ld hundredths\n", lDiff);

	lStart = get_time ();
	TestSep (src+1, dest, 0x8000);
	lDiff = get_time () - lStart;
	printf ("Seperate instructions src + 1 = %ld hundredths\n", lDiff);

	lStart = get_time ();
	TestSepOff (src, dest, 0x8000);
	lDiff = get_time () - lStart;
	printf ("Seperate instructions DWORD align, loop addr not aligned = %ld hundredths\n", lDiff);

	return (0);
}
